#!/usr/local/bin/perl -s

# tool for the foundations class on statistical language modeling by Dietrich Klakow
# it produces count files (absolute frequencies) of a corpus
# in case of questions please contact dietrich.klakow@lsv.uni-saarland.de 

$usage = "
usage: $0 WordList < TrainingCorpus > UnigramCnt 

   -h         this help
   -hh        this help


This tool takes a list of a all unique words seen in both training 
and testing corpus as the argument WordList. It  then reads from 
standard input the training corpus, accumulates the frequencies 
of the words and prints them finally to standard output.

";

die "$usage" if ( defined $h || defined $hh );

$List = shift;   # assign the filename of the WordList argument to a variable

die "WordList required. See also: \n $usage" if (!(defined $List));

open (List) || die "Error opening $List\n";   # open WordList

$NVoc = 0;                   # number of unique words in WordList
while ( <List> ) {           # process all words in WordList
    chop;                    # remove newlines from input
    $WList{$_} = 0;          # set counter for the present word to zero
    $Word[$NVoc] = $_;       # remember the string corresponding to the i-th word in the WordList
    $NVoc++;                 # increase counter
}

$NWords = 0;                 # number of words from the training corpus which are processed
while ( <> ) {               # process all words coming from standard input
    chop;
    $WList{$_}++;            # increase counter for present word
    $NWords++;               # one more word processed in training corpus
}

for ( $i = 0; $i < $NVoc; $i++) {              # loop over all words in WordList
    print "$i $Word[$i] $WList{$Word[$i]}\n";  # print index, string corresponding to the i-th word and the respective count
}

